package me.wazup.hideandseek.disguise;

import me.wazup.hideandseek.xseries.XMaterial;
import de.robingrether.idisguise.disguise.DisguiseType;
import de.robingrether.idisguise.disguise.Disguise;
import org.bukkit.OfflinePlayer;
import de.robingrether.idisguise.disguise.FallingBlockDisguise;
import org.bukkit.inventory.ItemStack;
import org.bukkit.entity.Player;
import org.bukkit.Bukkit;
import de.robingrether.idisguise.api.DisguiseAPI;

public class iDisguise extends DisguiseManager
{
    private final DisguiseAPI api;
    
    public iDisguise() {
        this.api = (DisguiseAPI)Bukkit.getServicesManager().getRegistration((Class)DisguiseAPI.class).getProvider();
    }
    
    @Override
    public void disguise(final Player player, final ItemStack itemStack) {
        this.api.disguise((OfflinePlayer)player, (Disguise)new FallingBlockDisguise(itemStack.getType()));
    }
    
    @Override
    public void disguise(final Player player, final String s) {
        this.api.disguise(player, DisguiseType.valueOf(s).newInstance());
    }
    
    @Override
    public void undisguise(final Player player) {
        this.api.undisguise((OfflinePlayer)player);
    }
    
    @Override
    public boolean valid() {
        try {
            new FallingBlockDisguise(XMaterial.GRASS_BLOCK.parseMaterial());
            return true;
        }
        catch (final Exception ex) {
            ex.printStackTrace();
            return false;
        }
    }
    
    @Override
    public String getName() {
        return "IDisguise";
    }
}
